d("plpSortView",['util'], function(UTIL) {

    return {
        extendSortView: function(plpView) {
            // Create Custom Sort View
            CCRZ.views.plpSortView = CCRZ.CloudCrazeView.extend({
                el: CCRZ.uiProperties.plpSortView.selector,
                viewName: "plpSortView",
                template: CCRZ.util.template(CCRZ.uiProperties.plpSortView.tmpl),
                init: function(){
                    this.render();
                },
                render: function(){
                    this.$el.html(this.template(CCRZ.productListPageView.model.toJSON()));
                },
                events: {
                    "click .cc_sort_option" : "sortAction",
                    "click .cc_reprint_sort" : "sortReprint"
                },
                sortReprint: function(event){
                    UTIL.showLoader();
                    let sortBySelection = $(event.currentTarget).data("id"), sortOrderSelection = $(event.currentTarget).data("order");
                    if(sortBySelection === CCRZ.productListPageView.headerView.model.get('sortBy') && sortOrderSelection === CCRZ.productListPageView.headerView.model.get('sortOrder')){
                        UTIL.hideLoader();
                    } else {
                        CCRZ.productListPageView.headerView.model.set('sortBy', sortBySelection);
                        CCRZ.productListPageView.headerView.model.set('sortOrder', sortOrderSelection);
                        let reqData = {
                            'searchText': CCRZ.productListPageView.headerView.model.get('searchText') + ' not EXCLUDE',
                            'type': 'search',
                            'UD_C64_1' : '1.0 Approved for Publication',
                            'sortType': (sortOrderSelection == 'asc'?'+':'-') + sortBySelection,
                            'offset': '0',
                            'pageSize': '100',
                            'isPDP' : false
                        }
                        let filterKey = ['Name', 'Publication', 'Color', 'Layout', 'Genre'];
                        filterKey.forEach(function(key){
                            let filterList = CCRZ.productListPageView.model.attributes['filter_' + key];
                            if(filterList.length > 0){
                                reqData['filter' + key] = filterList[0];
                            }
                        });
                        console.log('sorting started!');
                        UTIL.disableScroll();
                        CCRZ.productListPageView.model.set('isEndOfPageRender', false);
                        CCRZ.productListPageView.productItemsView.fetchReprint(reqData, false);
                    }
                },
                sortAction: function (event){
                    UTIL.showLoader();
                    let _this = this;
                    let sortBySelection = $(event.currentTarget).data("id"), sortOrderSelection = $(event.currentTarget).data("order");
                    if(sortBySelection === CCRZ.productListPageView.headerView.model.get('sortBy') && sortOrderSelection === CCRZ.productListPageView.headerView.model.get('sortOrder')){
                        UTIL.hideLoader();
                    } else {
                        plpView.headerView.sortAction(event);
                        setTimeout(() => {
                            _this.render();
                        }, 200);
                    }
                }
            });
            CCRZ.plpSortView = new CCRZ.views.plpSortView();
        }
    }
});

